Index: trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flodom.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flodom.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flodom.F90	(revision 2528)
@@ -4,4 +4,6 @@
    !! Ocean floats :   domain
    !!======================================================================
+   !! History :  OPA  ! 1998-07 (Y.Drillet, CLIPPER)  Original code
+   !!----------------------------------------------------------------------
 #if   defined key_floats   ||   defined key_esopa
    !!----------------------------------------------------------------------
@@ -12,5 +14,4 @@
    !!   dstnce         : compute distance between face mesh and floats 
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
@@ -20,17 +21,15 @@
 
    IMPLICIT NONE
-
-   !! * Accessibility
-   PRIVATE  dstnce
-   PUBLIC flo_dom     ! routine called by floats.F90
+   PRIVATE
+
+   PUBLIC   flo_dom    ! routine called by floats.F90
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -42,17 +41,14 @@
       !!
       !!  ** Method  :   We put the floats  in the domain with the latitude,
-      !!       the longitude (degree) and the depth (m).
-      !!
+      !!               the longitude (degree) and the depth (m).
       !!----------------------------------------------------------------------      
-      !! * Local declarations
-      LOGICAL  :: llinmesh
-      INTEGER  :: ji, jj, jk               ! DO loop index on 3 directions
-      INTEGER  :: jfl, jfl1                ! number of floats   
-      INTEGER  :: inum                     ! logical unit for file read
-      INTEGER, DIMENSION ( jpnfl    )  ::   &
-         iimfl, ijmfl, ikmfl,    &          ! index mesh of floats
-         idomfl,  ivtest, ihtest
-      REAL(wp) :: zdxab, zdyad
-      REAL(wp), DIMENSION ( jpnnewflo+1 )  :: zgifl, zgjfl,  zgkfl
+      LOGICAL  ::   llinmesh
+      INTEGER  ::   ji, jj, jk   ! DO loop index on 3 directions
+      INTEGER  ::   jfl, jfl1    ! number of floats   
+      INTEGER  ::   inum         ! logical unit for file read
+      INTEGER, DIMENSION(jpnfl) ::   iimfl, ijmfl, ikmfl       ! index mesh of floats
+      INTEGER, DIMENSION(jpnfl) ::   idomfl,  ivtest, ihtest   !   -             -
+      REAL(wp) ::   zdxab, zdyad
+      REAL(wp), DIMENSION(jpnnewflo+1)  :: zgifl, zgjfl,  zgkfl
       !!---------------------------------------------------------------------
       
@@ -102,5 +98,5 @@
                ivtest(jfl) = 0
                ikmfl(jfl) = 0
-# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
+# if   defined key_mpp_mpi
                DO ji = MAX(nldi,2), nlei
                   DO jj = MAX(nldj,2), nlej   ! NO vector opt.
@@ -139,5 +135,5 @@
             
             ! A zero in the sum of the arrays "ihtest" and "ivtest"             
-# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
+# if   defined key_mpp_mpi
             CALL mpp_sum(ihtest,jpnfl)
             CALL mpp_sum(ivtest,jpnfl)
@@ -233,5 +229,5 @@
             ivtest(jfl) = 0
             ikmfl(jfl) = 0
-# if   defined key_mpp_mpi   ||   defined key_mpp_shmem
+# if   defined key_mpp_mpi
             DO ji = MAX(nldi,2), nlei
                DO jj = MAX(nldj,2), nlej   ! NO vector opt.
@@ -357,9 +353,5 @@
       !!
       !! ** Method  : 
-      !!
-      !! History :
-      !!   8.0  !  98-07 (Y.Drillet)  Original code
       !!----------------------------------------------------------------------
-      !! * Arguments
       REAL(wp) ::   &
          pax, pay, pbx, pby,    &     ! ???
@@ -368,15 +360,13 @@
          ptx, pty                     ! ???
       LOGICAL ::  ldinmesh            ! ???
-
-      !! * local declarations
-      REAL(wp) ::   &
-         zabt, zbct, zcdt, zdat, zabpt, zbcpt, zcdpt, zdapt,  &
-         psax,psay,psbx,psby,psx,psy
-      REAL(wp) ::  fsline                ! Statement function
-
-      !! * Substitutions
-      fsline(psax, psay, psbx, psby, psx, psy) = psy  * ( psbx - psax )   &
-                                               - psx  * ( psby - psay )   &
-                                               + psax *   psby - psay * psbx
+      !!
+      REAL(wp) ::   zabt, zbct, zcdt, zdat, zabpt, zbcpt, zcdpt, zdapt
+      !!---------------------------------------------------------------------
+      !! Statement function
+      REAL(wp) ::   fsline
+      REAL(wp) ::   psax, psay, psbx, psby, psx, psy
+      fsline( psax, psay, psbx, psby, psx, psy ) = psy  * ( psbx - psax )   &
+         &                                       - psx  * ( psby - psay )   &
+         &                                       + psax *   psby - psay * psbx
       !!---------------------------------------------------------------------
       
@@ -411,5 +401,5 @@
          ldinmesh=.FALSE.
       ENDIF
-
+      !
    END SUBROUTINE findmesh
 
@@ -422,14 +412,11 @@
       !!                points
       !! ** Method  : 
-      !!         
       !!----------------------------------------------------------------------
-      !! * Arguments
       REAL(wp), INTENT(in) ::   pla1, phi1, pla2, phi2   ! ???
-
-      !! * Local variables
+      !!
       REAL(wp) ::   dly1, dly2, dlx1, dlx2, dlx, dls, dld, dpi
       REAL(wp) ::   dstnce
       !!---------------------------------------------------------------------
-      
+      !
       dpi  = 2.* ASIN(1.)
       dls  = dpi / 180.
@@ -438,12 +425,12 @@
       dlx1 = pla1 * dls
       dlx2 = pla2 * dls
-
+      !
       dlx = SIN(dly1) * SIN(dly2) + COS(dly1) * COS(dly2) * COS(dlx2-dlx1)
- 
+      !
       IF( ABS(dlx) > 1.0 ) dlx = 1.0
-
+      !
       dld = ATAN(DSQRT( ( 1-dlx )/( 1+dlx ) )) * 222.24 / dls
       dstnce = dld * 1000.
-
+      !
    END FUNCTION dstnce
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/FLO/flowri.F90	(revision 2528)
@@ -8,5 +8,4 @@
    !!   NEMO      1.0  ! 2002-11  (G. Madec, A. Bozec)  F90: Free form and module
    !!----------------------------------------------------------------------
-
 #if   defined key_floats   ||   defined key_esopa
    !!----------------------------------------------------------------------
@@ -32,9 +31,8 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -52,12 +50,11 @@
       CHARACTER (len=21) ::  clname
       INTEGER ::   inum   ! temporary logical unit for restart file
-      INTEGER ::   iafl, ibfl, icfl, ia1fl, ib1fl, ic1fl, jfl, irecflo,   &
+      INTEGER ::   iafl, ibfl, icfl, ia1fl, ib1fl, ic1fl, jfl, irecflo
       INTEGER ::   iafloc, ibfloc, ia1floc, ib1floc, iafln, ibfln
       INTEGER  ::    ic, jc , jpn
-      INTEGER, DIMENSION ( jpnij )  :: iproc
-
-      REAL(wp) :: zafl,zbfl,zcfl,zdtj
-      REAL(wp) :: zxxu, zxxu_01,zxxu_10, zxxu_11
-      REAL(wp), DIMENSION (jpk,jpnfl) :: ztemp, zsal
+      INTEGER, DIMENSION ( jpnij )  ::   iproc
+      REAL(wp) ::   zafl,zbfl,zcfl,zdtj
+      REAL(wp) ::   zxxu, zxxu_01,zxxu_10, zxxu_11
+      REAL(wp), DIMENSION (jpk,jpnfl) ::   ztemp, zsal   ! 2D workspace
       !!---------------------------------------------------------------------
       
@@ -74,5 +71,4 @@
          ! open the file numflo 
          CALL ctl_opn( numflo, 'trajec_float', 'REPLACE', 'UNFORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
-         !      REWIND numflo
 
          IF( kt == nit000 ) THEN
@@ -80,5 +76,5 @@
             IF(lwp) WRITE(numflo)cexper,no,irecflo,jpnfl,nn_writefl
          ENDIF
-         zdtj = rdt / 86400.      !!bug   use of 86400 instead of the phycst parameter
+         zdtj = rdt / 86400._wp
 
          ! translation of index position in geographical position
@@ -195,5 +191,5 @@
       !         iafln=NINT(tpifl(jfl))
       !         ibfln=NINT(tpjfl(jfl))
-      !# if defined key_mpp_mpi   ||   defined key_mpp_shmem
+      !# if defined key_mpp_mpi   
       !        IF ( (iafl >= (mig(nldi)-jpizoom+1)) .AND.
       !     $       (iafl <= (mig(nlei)-jpizoom+1)) .AND.
@@ -214,5 +210,5 @@
       !         ztemp(jfl)=tn(iafloc,ibfloc,jk)
       !         zsal(jfl)=sn(iaflo!,ibfloc,jk)
-      !# if defined key_mpp_mpi   ||   defined key_mpp_shmem
+      !# if defined key_mpp_mpi   
       !        ELSE
       !         ztemp(jfl) = 0.
@@ -298,5 +294,5 @@
 
       IF( kt == nitend )   CLOSE( numflo ) 
-    
+      !
    END SUBROUTINE flo_wri
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 2528)
@@ -9,4 +9,5 @@
    !!             3.0  !  2008-06  (G. Madec)   add ctmp4 to ctmp10
    !!             3.2  !  2009-08  (S. MAsson)  add new ctl_opn
+   !!             3.3  !  2010-10  (A. Coward)  add NetCDF4 usage
    !!----------------------------------------------------------------------
 
@@ -16,7 +17,7 @@
    !!   getunit    : give the index of an unused logical unit
    !!----------------------------------------------------------------------
-   USE par_kind        ! kind definition
-   USE par_oce         ! ocean parameter
-   USE lib_print       ! formated print library
+   USE par_oce       ! ocean parameter
+   USE lib_print     ! formated print library
+   USE nc4interface  ! NetCDF4 interface
 
    IMPLICIT NONE
@@ -26,91 +27,112 @@
    !!                   namrun namelist parameters
    !!----------------------------------------------------------------------
-   CHARACTER(len=16)  ::   cn_exp        = "exp0"      !: experiment name used for output filename
-   CHARACTER(len=32)  ::   cn_ocerst_in  = "restart"   !: suffix of ocean restart name (input)
-   CHARACTER(len=32)  ::   cn_ocerst_out = "restart"   !: suffix of ocean restart name (output)
-   LOGICAL            ::   ln_rstart     = .FALSE.     !: start from (F) rest or (T) a restart file
-   INTEGER            ::   nn_no         = 0           !: job number
-   INTEGER            ::   nn_rstctl     = 0           !: control of the time step (0, 1 or 2)
-   INTEGER            ::   nn_rstssh     = 0           !: hand made initilization of ssh or not (1/0)
-   INTEGER            ::   nn_it000      = 1           !: index of the first time step
-   INTEGER            ::   nn_itend      = 10          !: index of the last time step
-   INTEGER            ::   nn_date0      = 961115      !: initial calendar date aammjj
-   INTEGER            ::   nn_leapy      = 0           !: Leap year calendar flag (0/1 or 30)
-   INTEGER            ::   nn_istate     = 0           !: initial state output flag (0/1)
-   INTEGER            ::   nn_write      =   10        !: model standard output frequency
-   INTEGER            ::   nn_stock      =   10        !: restart file frequency
-   LOGICAL            ::   ln_dimgnnn    = .FALSE.     !: type of dimgout. (F): 1 file for all proc
+   CHARACTER(lc) ::   cn_exp        = "exp0"      !: experiment name used for output filename
+   CHARACTER(lc) ::   cn_ocerst_in  = "restart"   !: suffix of ocean restart name (input)
+   CHARACTER(lc) ::   cn_ocerst_out = "restart"   !: suffix of ocean restart name (output)
+   LOGICAL       ::   ln_rstart     = .FALSE.     !: start from (F) rest or (T) a restart file
+   INTEGER       ::   nn_no         = 0           !: job number
+   INTEGER       ::   nn_rstctl     = 0           !: control of the time step (0, 1 or 2)
+   INTEGER       ::   nn_rstssh     = 0           !: hand made initilization of ssh or not (1/0)
+   INTEGER       ::   nn_it000      = 1           !: index of the first time step
+   INTEGER       ::   nn_itend      = 10          !: index of the last time step
+   INTEGER       ::   nn_date0      = 961115      !: initial calendar date aammjj
+   INTEGER       ::   nn_leapy      = 0           !: Leap year calendar flag (0/1 or 30)
+   INTEGER       ::   nn_istate     = 0           !: initial state output flag (0/1)
+   INTEGER       ::   nn_write      =   10        !: model standard output frequency
+   INTEGER       ::   nn_stock      =   10        !: restart file frequency
+   LOGICAL       ::   ln_dimgnnn    = .FALSE.     !: type of dimgout. (F): 1 file for all proc
                                                        !:                  (T): 1 file per proc
-   LOGICAL            ::   ln_mskland    = .FALSE.     !: mask land points in NetCDF outputs (costly: + ~15%)
-   LOGICAL            ::   ln_clobber    = .FALSE.     !: clobber (overwrite) an existing file
-   INTEGER            ::   nn_chunksz    = 0           !: chunksize (bytes) for NetCDF file (working only with iom_nf90 routines)
+   LOGICAL       ::   ln_mskland    = .FALSE.     !: mask land points in NetCDF outputs (costly: + ~15%)
+   LOGICAL       ::   ln_clobber    = .FALSE.     !: clobber (overwrite) an existing file
+   INTEGER       ::   nn_chunksz    = 0           !: chunksize (bytes) for NetCDF file (works only with iom_nf90 routines)
+#if defined key_netcdf4
+   !!----------------------------------------------------------------------
+   !!                   namnc4 namelist parameters                         (key_netcdf4)
+   !!----------------------------------------------------------------------
+   ! The following four values determine the partitioning of the output fields
+   ! into netcdf4 chunks. They are unrelated to the nn_chunk_sz setting which is
+   ! for runtime optimisation. The individual netcdf4 chunks can be optionally 
+   ! gzipped (recommended) leading to significant reductions in I/O volumes 
+   !                                   !!!**  variables only used with iom_nf90 routines and key_netcdf4 **
+   INTEGER ::   nn_nchunks_i = 1        !: number of chunks required in the i-dimension 
+   INTEGER ::   nn_nchunks_j = 1        !: number of chunks required in the j-dimension 
+   INTEGER ::   nn_nchunks_k = 1        !: number of chunks required in the k-dimension 
+   INTEGER ::   nn_nchunks_t = 1        !: number of chunks required in the t-dimension 
+   LOGICAL ::   ln_nc4zip    = .TRUE.   !: netcdf4 usage: (T) chunk and compress output using the HDF5 sublayers of netcdf4
+   !                                    !                 (F) ignore chunking request and use the netcdf4 library 
+   !                                    !                     to produce netcdf3-compatible files 
+#endif
+!$AGRIF_DO_NOT_TREAT
+   TYPE(snc4_ctl)     :: snc4set        !: netcdf4 chunking control structure (always needed for decision making)
+!$AGRIF_END_DO_NOT_TREAT
+
 
    !! conversion of DOCTOR norm namelist name into model name
    !! (this should disappear in a near futur)
 
-   CHARACTER(len=16)  ::   cexper                      !: experiment name used for output filename
-   INTEGER            ::   no                          !: job number
-   INTEGER            ::   nrstdt                      !: control of the time step (0, 1 or 2)
-   INTEGER            ::   nit000                      !: index of the first time step
-   INTEGER            ::   nitend                      !: index of the last time step
-   INTEGER            ::   ndate0                      !: initial calendar date aammjj
-   INTEGER            ::   nleapy                      !: Leap year calendar flag (0/1 or 30)
-   INTEGER            ::   ninist                      !: initial state output flag (0/1)
-   INTEGER            ::   nwrite                      !: model standard output frequency
-   INTEGER            ::   nstock                      !: restart file frequency
+   CHARACTER(lc) ::   cexper                      !: experiment name used for output filename
+   INTEGER       ::   no                          !: job number
+   INTEGER       ::   nrstdt                      !: control of the time step (0, 1 or 2)
+   INTEGER       ::   nit000                      !: index of the first time step
+   INTEGER       ::   nitend                      !: index of the last time step
+   INTEGER       ::   ndate0                      !: initial calendar date aammjj
+   INTEGER       ::   nleapy                      !: Leap year calendar flag (0/1 or 30)
+   INTEGER       ::   ninist                      !: initial state output flag (0/1)
+   INTEGER       ::   nwrite                      !: model standard output frequency
+   INTEGER       ::   nstock                      !: restart file frequency
 
    !!----------------------------------------------------------------------
    !! was in restart but moved here because of the OFF line... better solution should be found...
    !!----------------------------------------------------------------------
-   INTEGER            ::   nitrst                 !: time step at which restart file should be written
+   INTEGER ::   nitrst   !: time step at which restart file should be written
 
    !!----------------------------------------------------------------------
    !!                    output monitoring
    !!----------------------------------------------------------------------
-   LOGICAL            ::   ln_ctl     = .FALSE.   !: run control for debugging
-   INTEGER            ::   nn_print     =    0    !: level of print (0 no print)
-   INTEGER            ::   nn_ictls     =    0    !: Start i indice for the SUM control
-   INTEGER            ::   nn_ictle     =    0    !: End   i indice for the SUM control
-   INTEGER            ::   nn_jctls     =    0    !: Start j indice for the SUM control
-   INTEGER            ::   nn_jctle     =    0    !: End   j indice for the SUM control
-   INTEGER            ::   nn_isplt     =    1    !: number of processors following i
-   INTEGER            ::   nn_jsplt     =    1    !: number of processors following j
-   INTEGER            ::   nn_bench     =    0    !: benchmark parameter (0/1)
-   INTEGER            ::   nn_bit_cmp   =    0    !: bit reproducibility  (0/1)
-
-   !                                              !: OLD namelist names
-   INTEGER ::   nprint, nictls, nictle, njctls, njctle, isplt, jsplt, nbench, nbit_cmp   
-
-   INTEGER            ::   ijsplt     =    1      !: nb of local domain = nb of processors
+   LOGICAL ::   ln_ctl     = .FALSE.   !: run control for debugging
+   INTEGER ::   nn_print     =    0    !: level of print (0 no print)
+   INTEGER ::   nn_ictls     =    0    !: Start i indice for the SUM control
+   INTEGER ::   nn_ictle     =    0    !: End   i indice for the SUM control
+   INTEGER ::   nn_jctls     =    0    !: Start j indice for the SUM control
+   INTEGER ::   nn_jctle     =    0    !: End   j indice for the SUM control
+   INTEGER ::   nn_isplt     =    1    !: number of processors following i
+   INTEGER ::   nn_jsplt     =    1    !: number of processors following j
+   INTEGER ::   nn_bench     =    0    !: benchmark parameter (0/1)
+   INTEGER ::   nn_bit_cmp   =    0    !: bit reproducibility  (0/1)
+
+   !                                          
+   INTEGER ::   nprint, nictls, nictle, njctls, njctle, isplt, jsplt, nbench    !: OLD namelist names
+
+   INTEGER ::   ijsplt     =    1      !: nb of local domain = nb of processors
 
    !!----------------------------------------------------------------------
    !!                        logical units
    !!----------------------------------------------------------------------
-   INTEGER            ::   numstp     =   -1      !: logical unit for time step
-   INTEGER            ::   numout     =    6      !: logical unit for output print
-   INTEGER            ::   numnam     =   -1      !: logical unit for namelist
-   INTEGER            ::   numnam_ice =   -1      !: logical unit for ice namelist
-   INTEGER            ::   numevo_ice =   -1      !: logical unit for ice variables (temp. evolution)
-   INTEGER            ::   numsol     =   -1      !: logical unit for solver statistics
+   INTEGER ::   numstp     =   -1      !: logical unit for time step
+   INTEGER ::   numout     =    6      !: logical unit for output print
+   INTEGER ::   numnam     =   -1      !: logical unit for namelist
+   INTEGER ::   numnam_ice =   -1      !: logical unit for ice namelist
+   INTEGER ::   numevo_ice =   -1      !: logical unit for ice variables (temp. evolution)
+   INTEGER ::   numsol     =   -1      !: logical unit for solver statistics
 
    !!----------------------------------------------------------------------
    !!                          Run control  
    !!----------------------------------------------------------------------
-   INTEGER            ::   nstop = 0                !: error flag (=number of reason for a premature stop run)
-   INTEGER            ::   nwarn = 0                !: warning flag (=number of warning found during the run)
-   CHARACTER(len=200) ::   ctmp1, ctmp2, ctmp3      !: temporary characters 1 to 3
-   CHARACTER(len=200) ::   ctmp4, ctmp5, ctmp6      !: temporary characters 4 to 6
-   CHARACTER(len=200) ::   ctmp7, ctmp8, ctmp9      !: temporary characters 7 to 9
-   CHARACTER(len=200) ::   ctmp10                   !: temporary character 10
-   CHARACTER (len=64) ::   cform_err = "(/,' ===>>> : E R R O R',     /,'         ===========',/)"       !:
-   CHARACTER (len=64) ::   cform_war = "(/,' ===>>> : W A R N I N G', /,'         ===============',/)"   !:
-   LOGICAL            ::   lwp      = .FALSE.       !: boolean : true on the 1st processor only
-   LOGICAL            ::   lsp_area = .TRUE.        !: to make a control print over a specific area
-   !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   INTEGER       ::   nstop = 0             !: error flag (=number of reason for a premature stop run)
+   INTEGER       ::   nwarn = 0             !: warning flag (=number of warning found during the run)
+   CHARACTER(lc) ::   ctmp1, ctmp2, ctmp3   !: temporary characters 1 to 3
+   CHARACTER(lc) ::   ctmp4, ctmp5, ctmp6   !: temporary characters 4 to 6
+   CHARACTER(lc) ::   ctmp7, ctmp8, ctmp9   !: temporary characters 7 to 9
+   CHARACTER(lc) ::   ctmp10                !: temporary character 10
+   CHARACTER(lc) ::   cform_err = "(/,' ===>>> : E R R O R',     /,'         ===========',/)"       !:
+   CHARACTER(lc) ::   cform_war = "(/,' ===>>> : W A R N I N G', /,'         ===============',/)"   !:
+   LOGICAL       ::   lwp      = .FALSE.    !: boolean : true on the 1st processor only
+   LOGICAL       ::   lsp_area = .TRUE.     !: to make a control print over a specific area
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -129,5 +151,5 @@
       nstop = nstop + 1 
       IF(lwp) THEN
-         WRITE(numout,"(/,' ===>>> : E R R O R',     /,'         ===========',/)") 
+         WRITE(numout,cform_err)
          IF( PRESENT(cd1 ) ) WRITE(numout,*) cd1
          IF( PRESENT(cd2 ) ) WRITE(numout,*) cd2
@@ -163,5 +185,5 @@
       nwarn = nwarn + 1 
       IF(lwp) THEN
-         WRITE(numout,"(/,' ===>>> : W A R N I N G', /,'         ===============',/)") 
+         WRITE(numout,cform_war)
          IF( PRESENT(cd1 ) ) WRITE(numout,*) cd1
          IF( PRESENT(cd2 ) ) WRITE(numout,*) cd2
@@ -180,5 +202,5 @@
 
 
-   SUBROUTINE ctl_opn ( knum, cdfile, cdstat, cdform, cdacce, klengh, kout, ldwp, karea )
+   SUBROUTINE ctl_opn( knum, cdfile, cdstat, cdform, cdacce, klengh, kout, ldwp, karea )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE ctl_opn  ***
@@ -187,10 +209,5 @@
       !!
       !! ** Method  :   Fortan open
-      !!
-      !! History :
-      !!        !  1995-12  (G. Madec)  Original code
-      !!   8.5  !  2002-06  (G. Madec)  F90: Free form and module
-      !!----------------------------------------------------------------------
-
+      !!----------------------------------------------------------------------
       INTEGER          , INTENT(  out) ::   knum      ! logical unit to open
       CHARACTER(len=*) , INTENT(in   ) ::   cdfile    ! file name to open
@@ -205,4 +222,5 @@
       CHARACTER(len=80) ::   clfile
       INTEGER           ::   iost
+      !!----------------------------------------------------------------------
 
       ! adapt filename
Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 2528)
@@ -44,4 +44,5 @@
 #endif
    PUBLIC iom_init, iom_swap, iom_open, iom_close, iom_setkt, iom_varid, iom_get, iom_gettime, iom_rstput, iom_put
+   PUBLIC iom_getatt
 
    PRIVATE iom_rp0d, iom_rp1d, iom_rp2d, iom_rp3d
@@ -54,4 +55,7 @@
    INTERFACE iom_get
       MODULE PROCEDURE iom_g0d, iom_g1d, iom_g2d, iom_g3d
+   END INTERFACE
+   INTERFACE iom_getatt
+      MODULE PROCEDURE iom_g0d_intatt
    END INTERFACE
    INTERFACE iom_rstput
@@ -68,7 +72,7 @@
 
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -824,4 +828,26 @@
       !
    END SUBROUTINE iom_gettime
+
+
+   !!----------------------------------------------------------------------
+   !!                   INTERFACE iom_getatt
+   !!----------------------------------------------------------------------
+   SUBROUTINE iom_g0d_intatt( kiomid, cdatt, pvar )
+      INTEGER         , INTENT(in   )                 ::   kiomid    ! Identifier of the file
+      CHARACTER(len=*), INTENT(in   )                 ::   cdatt     ! Name of the attribute
+      INTEGER         , INTENT(  out)                 ::   pvar      ! read field
+      !
+      IF( kiomid > 0 ) THEN
+         IF( iom_file(kiomid)%nfid > 0 ) THEN
+            SELECT CASE (iom_file(kiomid)%iolib)
+            CASE (jpioipsl )   ;   CALL ctl_stop('iom_getatt: only nf90 available')
+            CASE (jpnf90   )   ;   CALL iom_nf90_getatt( kiomid, cdatt, pvar )
+            CASE (jprstdimg)   ;   CALL ctl_stop('iom_getatt: only nf90 available')
+            CASE DEFAULT    
+               CALL ctl_stop( 'iom_g0d_att: accepted IO library are only jpioipsl, jpnf90 and jprstdimg' )
+            END SELECT
+         ENDIF
+      ENDIF
+   END SUBROUTINE iom_g0d_intatt
 
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_def.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_def.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_def.F90	(revision 2528)
@@ -8,7 +8,7 @@
    !!--------------------------------------------------------------------
    !!---------------------------------------------------------------------------------
-   !! OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!---------------------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 2528)
@@ -35,7 +35,7 @@
    END INTERFACE
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
